> ## Documentation Index
> Fetch the complete documentation index at: https://docs.whop.com/llms.txt
> Use this file to discover all available pages before exploring further.

# List products

> Returns a paginated list of products belonging to a company, with optional filtering by type, visibility, and creation date.

Required permissions:
 - `access_pass:basic:read`



## OpenAPI

````yaml /openapi/api-v1-stable.json get /products
openapi: 3.1.0
info:
  description: >-
    The Whop REST API. Please see
    https://docs.whop.com/developer/api/getting-started for more details.
  termsOfService: https://whop.com/tos-developer-api/
  title: Whop API
  version: 1.0.0
  x-api-version-date: '2026-08-21'
servers:
  - description: Production Whop API
    url: https://api.whop.com/api/v1
  - description: Sandbox Whop API
    url: https://sandbox-api.whop.com/api/v1
security: []
tags:
  - description: Products
    name: Products
  - description: Payments
    name: Payments
  - description: Refunds
    name: Refunds
  - description: Disputes
    name: Disputes
  - description: Dispute alerts
    name: Dispute alerts
  - description: Resolution center cases
    name: Resolution center cases
  - description: Checkout configurations
    name: Checkout configurations
  - description: Setup intents
    name: Setup intents
  - description: Payment methods
    name: Payment methods
  - description: Invoices
    name: Invoices
  - description: Promo codes
    name: Promo codes
  - description: Card transactions
    name: Card transactions
  - description: Ledger accounts
    name: Ledger accounts
  - description: Withdrawals
    name: Withdrawals
  - description: Payout methods
    name: Payout methods
  - description: Verifications
    name: Verifications
  - description: Identity profiles
    name: Identity profiles
  - description: Payout accounts
    name: Payout accounts
  - description: Topups
    name: Topups
  - description: Companies
    name: Companies
  - description: Authorized users
    name: Authorized users
  - description: Fee markups
    name: Fee markups
  - description: Members
    name: Members
  - description: Memberships
    name: Memberships
  - description: Leads
    name: Leads
  - description: Entries
    name: Entries
  - description: Shipments
    name: Shipments
  - description: Reviews
    name: Reviews
  - description: Company token transactions
    name: Company token transactions
  - description: Affiliates
    name: Affiliates
  - description: Experiences
    name: Experiences
  - description: Forums
    name: Forums
  - description: Forum posts
    name: Forum posts
  - description: Chat channels
    name: Chat channels
  - description: Support channels
    name: Support channels
  - description: Messages
    name: Messages
  - description: Reactions
    name: Reactions
  - description: Dm members
    name: Dm members
  - description: Dm channels
    name: Dm channels
  - description: Notifications
    name: Notifications
  - description: Courses
    name: Courses
  - description: Course chapters
    name: Course chapters
  - description: Course lessons
    name: Course lessons
  - description: Course students
    name: Course students
  - description: Course lesson interactions
    name: Course lesson interactions
  - description: Apps
    name: Apps
  - description: Webhooks
    name: Webhooks
  - description: App builds
    name: App builds
  - description: Access tokens
    name: Access tokens
  - description: Account links
    name: Account links
  - description: Files
    name: Files
  - description: Ai chats
    name: Ai chats
  - description: Bounties
    name: Bounties
  - description: Stats
    name: Stats
  - description: Conversions
    name: Conversions
  - description: Ad reports
    name: Ad reports
paths:
  /products:
    get:
      tags:
        - Products
      summary: List products
      description: >-
        Returns a paginated list of products belonging to a company, with
        optional filtering by type, visibility, and creation date.


        Required permissions:
         - `access_pass:basic:read`
      operationId: listProduct
      parameters:
        - explode: true
          in: query
          name: after
          required: false
          schema:
            description: >-
              Returns the elements in the list that come after the specified
              cursor.
            type: string
          style: form
        - explode: true
          in: query
          name: before
          required: false
          schema:
            description: >-
              Returns the elements in the list that come before the specified
              cursor.
            type: string
          style: form
        - explode: true
          in: query
          name: first
          required: false
          schema:
            description: Returns the first _n_ elements from the list.
            example: 42
            type: integer
          style: form
        - explode: true
          in: query
          name: last
          required: false
          schema:
            description: Returns the last _n_ elements from the list.
            example: 42
            type: integer
          style: form
        - explode: true
          in: query
          name: company_id
          required: true
          schema:
            description: The unique identifier of the company to list products for.
            example: biz_xxxxxxxxxxxxxx
            type: string
          style: form
        - explode: true
          in: query
          name: product_types
          required: false
          schema:
            description: Filter to only products matching these type classifications.
            items:
              $ref: '#/components/schemas/AccessPassTypes'
            type: array
          style: form
        - explode: true
          in: query
          name: visibilities
          required: false
          schema:
            description: Filter to only products matching these visibility states.
            items:
              $ref: '#/components/schemas/VisibilityFilter'
            type: array
          style: form
        - explode: true
          in: query
          name: order
          required: false
          schema:
            $ref: '#/components/schemas/AccessPassOrder'
            description: The field to sort results by. Defaults to created_at.
          style: form
        - explode: true
          in: query
          name: direction
          required: false
          schema:
            $ref: '#/components/schemas/Direction'
            description: The sort direction for results. Defaults to descending.
          style: form
        - explode: true
          in: query
          name: created_before
          required: false
          schema:
            description: Only return products created before this timestamp.
            example: '2023-12-01T05:00:00.401Z'
            format: date-time
            type: string
          style: form
        - explode: true
          in: query
          name: created_after
          required: false
          schema:
            description: Only return products created after this timestamp.
            example: '2023-12-01T05:00:00.401Z'
            format: date-time
            type: string
          style: form
      responses:
        '200':
          content:
            application/json:
              schema:
                description: The connection type for PublicAccessPass.
                properties:
                  data:
                    description: A list of nodes.
                    items:
                      $ref: '#/components/schemas/ProductListItem'
                    type: array
                  page_info:
                    $ref: '#/components/schemas/PageInfo'
                    description: Information to aid in pagination.
                required:
                  - data
                  - page_info
                type: object
          description: A successful response
        '400':
          content:
            application/json:
              example:
                error:
                  code: parameter_missing
                  message: 'Missing required parameter: amount.'
                  param: amount
                  type: invalid_request_error
              schema:
                properties:
                  error:
                    properties:
                      code:
                        description: >-
                          A short string indicating the specific error code,
                          e.g. 'parameter_missing', 'parameter_invalid',
                          'invalid_json'
                        type:
                          - string
                          - 'null'
                      message:
                        type: string
                      param:
                        description: The parameter that caused the error, if applicable
                        type:
                          - string
                          - 'null'
                      type:
                        type: string
                    required:
                      - type
                      - message
                    type: object
                required:
                  - error
                type: object
          description: Bad request
        '401':
          content:
            application/json:
              example:
                error:
                  message: Invalid or missing API key
                  type: unauthorized
              schema:
                properties:
                  error:
                    properties:
                      code:
                        description: >-
                          A short string indicating the specific error code,
                          e.g. 'parameter_missing', 'parameter_invalid',
                          'invalid_json'
                        type:
                          - string
                          - 'null'
                      message:
                        type: string
                      param:
                        description: The parameter that caused the error, if applicable
                        type:
                          - string
                          - 'null'
                      type:
                        type: string
                    required:
                      - type
                      - message
                    type: object
                required:
                  - error
                type: object
          description: Unauthorized
        '403':
          content:
            application/json:
              example:
                error:
                  message: You do not have permission to access this resource
                  type: forbidden
              schema:
                properties:
                  error:
                    properties:
                      code:
                        description: >-
                          A short string indicating the specific error code,
                          e.g. 'parameter_missing', 'parameter_invalid',
                          'invalid_json'
                        type:
                          - string
                          - 'null'
                      message:
                        type: string
                      param:
                        description: The parameter that caused the error, if applicable
                        type:
                          - string
                          - 'null'
                      type:
                        type: string
                    required:
                      - type
                      - message
                    type: object
                required:
                  - error
                type: object
          description: Forbidden
        '404':
          content:
            application/json:
              example:
                error:
                  message: Resource not found
                  type: not_found
              schema:
                properties:
                  error:
                    properties:
                      code:
                        description: >-
                          A short string indicating the specific error code,
                          e.g. 'parameter_missing', 'parameter_invalid',
                          'invalid_json'
                        type:
                          - string
                          - 'null'
                      message:
                        type: string
                      param:
                        description: The parameter that caused the error, if applicable
                        type:
                          - string
                          - 'null'
                      type:
                        type: string
                    required:
                      - type
                      - message
                    type: object
                required:
                  - error
                type: object
          description: Not found
        '422':
          content:
            application/json:
              example:
                error: null
              schema:
                properties:
                  error:
                    properties:
                      code:
                        description: >-
                          A short string indicating the specific error code,
                          e.g. 'parameter_missing', 'parameter_invalid',
                          'invalid_json'
                        type:
                          - string
                          - 'null'
                      message:
                        type: string
                      param:
                        description: The parameter that caused the error, if applicable
                        type:
                          - string
                          - 'null'
                      type:
                        type: string
                    required:
                      - type
                      - message
                    type: object
                required:
                  - error
                type: object
          description: Verification required
        '429':
          content:
            application/json:
              example:
                error: null
              schema:
                properties:
                  error:
                    properties:
                      code:
                        description: >-
                          A short string indicating the specific error code,
                          e.g. 'parameter_missing', 'parameter_invalid',
                          'invalid_json'
                        type:
                          - string
                          - 'null'
                      message:
                        type: string
                      param:
                        description: The parameter that caused the error, if applicable
                        type:
                          - string
                          - 'null'
                      type:
                        type: string
                    required:
                      - type
                      - message
                    type: object
                required:
                  - error
                type: object
          description: Too many requests
        '500':
          content:
            application/json:
              example:
                error:
                  message: An unexpected error occurred
                  type: internal_server_error
              schema:
                properties:
                  error:
                    properties:
                      code:
                        description: >-
                          A short string indicating the specific error code,
                          e.g. 'parameter_missing', 'parameter_invalid',
                          'invalid_json'
                        type:
                          - string
                          - 'null'
                      message:
                        type: string
                      param:
                        description: The parameter that caused the error, if applicable
                        type:
                          - string
                          - 'null'
                      type:
                        type: string
                    required:
                      - type
                      - message
                    type: object
                required:
                  - error
                type: object
          description: Internal server error
      security:
        - bearerAuth:
            - access_pass:basic:read
      x-codeSamples:
        - lang: JavaScript
          source: >-
            import Whop from '@whop/sdk';


            const client = new Whop({
              apiKey: process.env['WHOP_API_KEY'], // This is the default and can be omitted
            });


            // Automatically fetches more pages as needed.

            for await (const productListItem of client.products.list({
            account_id: 'account_id' })) {
              console.log(productListItem.id);
            }
components:
  schemas:
    AccessPassTypes:
      description: >-
        The different types an product can be. Only use 'regular'. The rest are
        for internal use
      enum:
        - regular
        - app
        - experience_upsell
        - api_only
      type: string
    VisibilityFilter:
      description: The different levels of visibility for resources
      enum:
        - visible
        - hidden
        - archived
        - quick_link
        - all
        - not_quick_link
        - not_archived
      type: string
    AccessPassOrder:
      description: The ways a relation of AccessPasses can be ordered
      enum:
        - active_memberships_count
        - created_at
        - usd_gmv
        - usd_gmv_30_days
      type: string
    Direction:
      description: The direction of the sort.
      enum:
        - asc
        - desc
      type: string
    ProductListItem:
      description: >-
        A product is a digital good or service sold on Whop. Products contain
        plans for pricing and experiences for content delivery.
      properties:
        created_at:
          description: The datetime the product was created.
          example: '2023-12-01T05:00:00.401Z'
          format: date-time
          type: string
        external_identifier:
          description: >-
            External identifier for the product. Providing it on a product
            creation endpoint updates the existing product with this identifier
            instead of creating a new one.
          example: ext_prod_12345
          type:
            - string
            - 'null'
        gallery_images:
          description: The gallery images for this product, ordered by position.
          items:
            description: Represents an image attachment
            properties:
              content_type:
                description: >-
                  Uploaded file MIME type, such as image/jpeg, video/mp4, or
                  audio/mpeg.
                example: image/jpeg
                type:
                  - string
                  - 'null'
              id:
                description: >-
                  Represents a unique identifier that is Base64 obfuscated. It
                  is often used to refetch an object or as key for a cache. The
                  ID type appears in a JSON response as a String; however, it is
                  not intended to be human-readable. When expected as an input
                  type, any string (such as `"VXNlci0xMA=="`) or integer (such
                  as `4`) input value will be accepted as an ID.
                type: string
              url:
                description: >-
                  A pre-optimized URL for rendering this attachment on the
                  client. This should be used for displaying attachments in
                  apps.
                example: https://media.whop.com/abc123/optimized.jpg
                type:
                  - string
                  - 'null'
            required:
              - id
              - url
              - content_type
            type: object
          type: array
        headline:
          description: >-
            A short marketing headline displayed prominently on the product's
            product page.
          example: Real-time data analytics for creators
          type:
            - string
            - 'null'
        id:
          description: The unique identifier for the product.
          example: prod_xxxxxxxxxxxxx
          type: string
        member_count:
          description: >-
            Active memberships for this product. Returns `0` if the account has
            disabled public member counts.
          example: 42
          type: integer
        metadata:
          additionalProperties: true
          description: >-
            Custom key-value pairs stored on the product and included in payment
            and membership webhook payloads. Max 50 keys, 100 characters per
            key, 500 characters per string value.
          type:
            - object
            - 'null'
        published_reviews_count:
          description: >-
            The total number of published customer reviews for this product's
            company.
          example: 42
          type: integer
        route:
          description: >-
            URL slug in the product's public link, e.g. `pickaxe-analytics` in
            whop.com/company/pickaxe-analytics.
          example: pickaxe-analytics
          type: string
        title:
          description: >-
            The display name of the product shown to customers on the product
            page and in search results.
          example: Pickaxe Analytics
          type: string
        updated_at:
          description: The datetime the product was last updated.
          example: '2023-12-01T05:00:00.401Z'
          format: date-time
          type: string
        verified:
          description: >-
            Whether this company has been verified by Whop's trust and safety
            team.
          type: boolean
        visibility:
          $ref: '#/components/schemas/Visibility'
          description: >-
            Controls whether the product is visible to customers. When set to
            'hidden', the product is only accessible via direct link.
      required:
        - id
        - title
        - visibility
        - headline
        - verified
        - created_at
        - updated_at
        - member_count
        - route
        - published_reviews_count
        - external_identifier
        - metadata
        - gallery_images
      type: object
    PageInfo:
      description: Information about pagination in a connection.
      properties:
        end_cursor:
          description: When paginating forwards, the cursor to continue.
          type:
            - string
            - 'null'
        has_next_page:
          description: When paginating forwards, are there more items?
          type: boolean
        has_previous_page:
          description: When paginating backwards, are there more items?
          type: boolean
        start_cursor:
          description: When paginating backwards, the cursor to continue.
          type:
            - string
            - 'null'
      required:
        - end_cursor
        - start_cursor
        - has_next_page
        - has_previous_page
      type: object
    Visibility:
      description: Visibility of a resource
      enum:
        - visible
        - hidden
        - archived
        - quick_link
      type: string
  securitySchemes:
    bearerAuth:
      bearerFormat: auth-scheme
      description: >-
        An Account API key, account-scoped JWT, App API key, or user OAuth
        token. Prepend the key or token with `Bearer`, for example `Bearer
        ***************************`.
      scheme: bearer
      type: http

````